--
-- Ideal IIR filter
-- Used by simulations
--
library ieee;
use work.iir_types.all;
-- use ieee.math_real.all;


entity ideal_iir is
   port (x : in real;
         y : out real;
         a1: in filter_coeff;
         a2: in filter_coeff;
         b1: in filter_coeff;
         b2: in filter_coeff);
end entity ideal_iir;

--
-- Implementation
--
architecture behaviour of ideal_iir is
   type intermediat_values is array (natural range a1'left to a1'right+1) of real;
   signal h : intermediat_values := (others => 0.0);
begin
   h(0) <= x;
   sos1: entity ideal_biquad(behaviour)
      port map (x => y(i),
                y => y(i+1),
                a1 => a1(i),
                a2 => a2(i),
                b1 => b1(i),
                b2 => b2(i));
   -- compute second-order section
   y <= h(a1'right);
end architecture behaviour;




